import bodyParser from "body-parser";
import cors from "cors";
import express from "express";

let api = express.Router();

const initApi = async (app) => {
  app.set("json spaces", 2);
  app.use("/api", api);
};

/* NOTE: bodyParser has a default request body limit of 10 MB. You can increase it like this: */
api.use(bodyParser.json({ limit: "100mb" }));
api.use(cors());

api.get("/", (req, res) => {
  res.json({ message: "Hello, world!" });
});

let FILE = null;

api.post("/upload", (req, res) => {
  let filename = req.body.filename;
  let content = req.body.content;
  /* TODO: You can store the file in the database or similar. Note that MongoDB has a limit on how
     big each document can be. If you want to handle larger files, post on Ed, and we'll give you some
     support code. */
  FILE = { filename, content };
  res.json({ success: true });
});

api.get("/download", (req, res) => {
  if (!FILE) {
    res.status(400).json({ error: "No file uploaded" });
    return;
  }
  res.json({ filename: FILE.filename, content: FILE.content });
});

/* Catch-all route to return a JSON error if endpoint not defined.
   Be sure to put all of your endpoints above this one, or they will not be called. */
api.all("/*", (req, res) => {
  res.status(404).json({ error: `Endpoint not found: ${req.method} ${req.url}` });
});

export default initApi;
